<template>
  <div class="container mx-auto flex flex-col items-center bg-gray-100 p-4">
    <div v-if="!pageLoaded"
         class="fixed w-100 h-100 opacity-80 bg-purple-800 inset-0 z-50 flex items-center justify-center">
      <svg class="animate-spin -ml-1 mr-3 h-12 w-12 text-white" xmlns="http://www.w3.org/2000/svg" fill="none"
           viewBox="0 0 24 24">
        <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="4"></circle>
        <path class="opacity-75" fill="currentColor"
              d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"></path>
      </svg>
    </div>
    <div class="container">

      <ticker-input
          :existing-tickers="tickerObjects"
          v-on:add-ticker="handleAddTicker($event)"
      />

      <template v-if="tickerObjects.length > 0">
        <pagination
            :tickers-limit="6"
            :tickers-list="filteredTickers"
            :initial-page-state="page"
            :reset-pagination="this.resetPagination"
            v-on:pagination-updated="handlePagination($event)"
        />

        <filtration
            :tickers-list="tickerObjects"
            :filter-initial-state="filter"
            v-on:filter-updated="handleFilterUpdate($event)"
        />

        <hr class="w-full border-t border-gray-600 my-4"/>

        <ticker-listing
            :tickers="paginatedTickers"
            :unselect-ticker="selectedTicker === ''"
            v-on:ticker-selected="setSelectedTicker($event)"
            v-on:ticker-unselected="setSelectedTicker('')"
            v-on:remove-ticker="removeTicker($event)"/>

        <hr class="w-full border-t border-gray-600 my-4"/>
      </template>
      <graph
          v-if="selectedTicker"
          :from-currency-name="this.selectedTicker.name"
          :graph-values="selectedTickerPricesList"
          to-currency-name="USD"
          v-on:graph-closed="handleCloseGraph"/>
    </div>
  </div>
</template>

<script>

import {subscribeToTickerUpdate, unsubscribeFromTickerUpdate} from "@/api/subscriptionsApi";
//import {saveTickersStateToLocalStorage, getTickersStateFromLocalStorage} from "@/api/persistenceApi";
import TickersListing from "@/components/TickersListing";
import Graph from "@/components/Graph";
import Pagination from "@/components/Pagination";
import Filter from "@/components/Filter";
import TickerInput from "@/components/TickerInput";
import { mapState, mapActions } from "vuex";
import {ACTIONS as storeActions} from "@/store/constants.js";

export default {
  name: 'App',
  components: {
    "ticker-listing": TickersListing,
    "graph": Graph,
    "pagination": Pagination,
    "filtration": Filter,
    "ticker-input": TickerInput
  },
  data() {
    return {
      paginatedTickers: [],
      filteredTickers: [],
      selectedTicker: "",
      selectedTickerPricesList: [],
      searchSuggestions: [],
      breakSearch: true,
      searchTimerId: null,
      pageLoaded: false,
      filter: "",
      page: 1,
      resetPagination: false,
      componentMounted: false,
    }
  },

  methods: {
    ...mapActions({
      addTickerToStorage: storeActions.ADD_TICKER_TO_LIST,
      removeTickerFromStorage: storeActions.REMOVE_TICKER_FROM_LIST,
      setStoreTickersList: storeActions.SET_TICKERS_LIST,
      loadTickersListFromStorage: storeActions.LOAD_TICKERS_LIST_FROM_STORAGE,
      saveTickersListToStorage: storeActions.SAVE_TICKERS_LIST_TO_STORAGE
    }),

    handlePagination(paginationState) {
      this.resetPagination = false;
      this.paginatedTickers = paginationState.paginatedTickers;
      this.page = paginationState.currentPage;
    },

    handleFilterUpdate(filterState) {
      this.filter = filterState.filter;
      this.filteredTickers = filterState.filteredTickers;
    },

    updateTicker(tickerName, price) {
      this.tickerObjects.filter(t => t.name === tickerName).forEach(t => {
        t.price = price;
        if (this.selectedTicker && this.selectedTicker.id === t.id) {
          this.selectedTickerPricesList.push(price);
        }
      });
    },

    markTickerWithError(tickerName, message) {
      this.tickerObjects.find(ticker => ticker.name === tickerName).errorMsg = message;
    },

    handleAddTicker(newTickerObject) {
      this.addTickerToStorage(newTickerObject);

      subscribeToTickerUpdate(newTickerObject.name,
          newPrice => this.updateTicker(newTickerObject.name, newPrice),
          errorMessage => this.markTickerWithError(newTickerObject.name, errorMessage)
      )
    },

    removeTicker(ticker) {
      this.removeTickerFromStorage(ticker);
      if (this.selectedTicker && this.selectedTicker.id === ticker.id) {
        this.selectedTicker = null;
      }
      unsubscribeFromTickerUpdate(ticker.name);
    },

    setSelectedTicker(selected) {
      this.selectedTicker = selected;
    },

    handleCloseGraph() {
      this.selectedTicker = ''
    }
  },

  computed: {
    ...mapState({
      tickerObjects: 'tickersList'
    }),

    pageStateOptions() {
      return {
        page: this.page,
        filter: this.filter
      }
    }
  },

  created() {
    this.loadTickersListFromStorage()
        .then(() => {
          this.tickerObjects.forEach(ticker =>
              subscribeToTickerUpdate(ticker.name,
                  newPrice => this.updateTicker(ticker.name, newPrice),
                  errorMessage => this.markTickerWithError(ticker.name, errorMessage)
              )
          )
        })

    const windowData = Object.fromEntries(new URL(window.location).searchParams.entries());
    const VALID_WINDOW_DATA_KEYS = ["filter", "page"];

    VALID_WINDOW_DATA_KEYS.forEach(key => {
      if (windowData[key]) {
        this[key] = key === 'page' ? Number.parseInt(windowData[key]) : windowData[key];
      }
    });
  },

  mounted() {
    this.componentMounted = true;
    setTimeout(() => {
      this.pageLoaded = true;
    }, 500)
  },

  watch: {
    tickerObjects() {
      this.saveTickersListToStorage();
      /*saveTickersStateToLocalStorage(this.tickerObjects);*/
    },

    selectedTicker() {
      this.selectedTickerPricesList = [];
    },

    filter() {
      this.resetPagination = true;
    },

    pageStateOptions(value) {
      this.$router.push({
        path: this.$route.path,
        query: {
          filter: value.filter,
          page: value.page
        }
      })
    }
  }
}
</script>
